//*****************************************************************************
//*****************************************************************************
//  FILENAME:  ADCINC14_1.h
//  Version: 1.3, Updated on 2006/04/28 at 14:26:34
//  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
//
//  DESCRIPTION:  ADCINC14 User Module C Language interface file for the
//                22/24/25/26/27xxx PSoC family of devices.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8C.h>

//-------------------------------------------------
// Defines for ADCINC14_1 API's.
//-------------------------------------------------

// Power Setting Constants
#define ADCINC14_1_OFF            0
#define ADCINC14_1_LOWPOWER       1
#define ADCINC14_1_MEDPOWER       2
#define ADCINC14_1_HIGHPOWER      3

// Function Fastcall Pragmas
#pragma fastcall16 ADCINC14_1_Start
#pragma fastcall16 ADCINC14_1_SetPower
#pragma fastcall16 ADCINC14_1_GetSamples
#pragma fastcall16 ADCINC14_1_StopAD
#pragma fastcall16 ADCINC14_1_Stop
#pragma fastcall16 ADCINC14_1_fIsData
#pragma fastcall16 ADCINC14_1_fIsDataAvailable
#pragma fastcall16 ADCINC14_1_iGetData
#pragma fastcall16 ADCINC14_1_iGetDataClearFlag
#pragma fastcall16 ADCINC14_1_ClearFlag

//-------------------------------------------------
// Prototypes of the ADCINC14_1 API.
//-------------------------------------------------

extern void ADCINC14_1_Start(BYTE bPower);
extern void ADCINC14_1_SetPower(BYTE bPower);
extern void ADCINC14_1_GetSamples(BYTE bNumSamples);
extern void ADCINC14_1_StopAD(void);
extern void ADCINC14_1_Stop(void);
extern CHAR ADCINC14_1_fIsData(void);
extern CHAR ADCINC14_1_fIsDataAvailable(void);
extern INT  ADCINC14_1_iGetData(void);
extern INT  ADCINC14_1_iGetDataClearFlag(void);
extern void ADCINC14_1_ClearFlag(void);

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------

// Integrator Block Register Definitions
#pragma ioport  ADCINC14_1_bfAtoDcr0:   0x080
BYTE            ADCINC14_1_bfAtoDcr0;
#pragma ioport  ADCINC14_1_bfAtoDcr1:   0x081
BYTE            ADCINC14_1_bfAtoDcr1;
#pragma ioport  ADCINC14_1_bfAtoDcr2:   0x082
BYTE            ADCINC14_1_bfAtoDcr2;
#pragma ioport  ADCINC14_1_bfAtoDcr3:   0x083
BYTE            ADCINC14_1_bfAtoDcr3;

// Counter Block Register Definitions
#pragma ioport  ADCINC14_1_fCounterFN:  0x140
BYTE            ADCINC14_1_fCounterFN;
#pragma ioport  ADCINC14_1_fCounterSL:  0x141
BYTE            ADCINC14_1_fCounterSL;
#pragma ioport  ADCINC14_1_fCounterOS:  0x142
BYTE            ADCINC14_1_fCounterOS;
#pragma ioport  ADCINC14_1_bCount:  0x040
BYTE            ADCINC14_1_bCount;
#pragma ioport  ADCINC14_1_bPeriod: 0x041
BYTE            ADCINC14_1_bPeriod;
#pragma ioport  ADCINC14_1_bCompare:    0x042
BYTE            ADCINC14_1_bCompare;
#pragma ioport  ADCINC14_1_bCounter_CR0:    0x043
BYTE            ADCINC14_1_bCounter_CR0;


// PWM24 Block Register Definitions
#pragma ioport  ADCINC14_1_bfPWM_LSB_FN:    0x144
BYTE            ADCINC14_1_bfPWM_LSB_FN;
#pragma ioport  ADCINC14_1_bfPWM_ISB_FN:    0x148
BYTE            ADCINC14_1_bfPWM_ISB_FN;
#pragma ioport  ADCINC14_1_bfPWM_MSB_FN:    0x14c
BYTE            ADCINC14_1_bfPWM_MSB_FN;
#pragma ioport  ADCINC14_1_fPWM_LSB_CR0:    0x047
BYTE            ADCINC14_1_fPWM_LSB_CR0;
#pragma ioport  ADCINC14_1_fPWM_ISB_CR0:    0x04b
BYTE            ADCINC14_1_fPWM_ISB_CR0;
#pragma ioport  ADCINC14_1_fPWM_MSB_CR0:    0x04f
BYTE            ADCINC14_1_fPWM_MSB_CR0;
#pragma ioport  ADCINC14_1_bPWM_Count_MSB:  0x04c
BYTE            ADCINC14_1_bPWM_Count_MSB;
#pragma ioport  ADCINC14_1_bPWM_Count_LSB:  0x044
BYTE            ADCINC14_1_bPWM_Count_LSB;
#pragma ioport  ADCINC14_1_bPWM_Count_ISB:  0x048
BYTE            ADCINC14_1_bPWM_Count_ISB;
#pragma ioport  ADCINC14_1_bPWM_Period_MSB: 0x04d
BYTE            ADCINC14_1_bPWM_Period_MSB;
#pragma ioport  ADCINC14_1_bPWM_Period_LSB: 0x045
BYTE            ADCINC14_1_bPWM_Period_LSB;
#pragma ioport  ADCINC14_1_bPWM_Period_ISB: 0x049
BYTE            ADCINC14_1_bPWM_Period_ISB;
#pragma ioport  ADCINC14_1_bPWM_IntTime_LSB:    0x046
BYTE            ADCINC14_1_bPWM_IntTime_LSB;
#pragma ioport  ADCINC14_1_bPWM_IntTime_ISB:    0x04a
BYTE            ADCINC14_1_bPWM_IntTime_ISB;
#pragma ioport  ADCINC14_1_bPWM_IntTime_MSB:    0x04e
BYTE            ADCINC14_1_bPWM_IntTime_MSB;
#pragma ioport  ADCINC14_1_bfPWM_LSB_FN:    0x144
BYTE            ADCINC14_1_bfPWM_LSB_FN;
#pragma ioport  ADCINC14_1_bfPWM_ISB_FN:    0x148
BYTE            ADCINC14_1_bfPWM_ISB_FN;
#pragma ioport  ADCINC14_1_bfPWM_MSB_FN:    0x14c
BYTE            ADCINC14_1_bfPWM_MSB_FN;

// end of file ADCINC14_1.h
