//*****************************************************************************
//*****************************************************************************
//  FILENAME: RX8_2.h
//   Version: 3.3, Updated on 2006/05/30 at 10:18:42
//  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
//
//  DESCRIPTION:  RX8 User Module C Language interface file for the
//                22/24/25/26/27xxx PSoC family of devices.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************


// include the global header file
#include <m8c.h>

#define RX8_2_RXBUF_ENABLE 0

//-------------------------------------------------
// Prototypes of the RX8_2 API.
//-------------------------------------------------

#if ( RX8_2_RXBUF_ENABLE )
extern char RX8_2_aRxBuffer[];
extern BYTE RX8_2_bRxCnt;
extern BYTE RX8_2_fStatus;
#endif

// Create pragmas to support proper argument and return value passing
#pragma fastcall16  RX8_2_EnableInt
#pragma fastcall16  RX8_2_DisableInt
#pragma fastcall16  RX8_2_Start
#pragma fastcall16  RX8_2_Stop
#pragma fastcall16  RX8_2_bReadRxData
#pragma fastcall16  RX8_2_bReadRxStatus

#pragma fastcall16  RX8_2_cGetChar
#pragma fastcall16  RX8_2_cReadChar
#pragma fastcall16  RX8_2_iReadChar

#if ( RX8_2_RXBUF_ENABLE )
#pragma fastcall16  RX8_2_CmdReset
#pragma fastcall16  RX8_2_bCmdCheck
#pragma fastcall16  RX8_2_bErrCheck
#pragma fastcall16  RX8_2_bCmdLength
#pragma fastcall16  RX8_2_szGetParam
#pragma fastcall16  RX8_2_szGetRestOfParams
#endif

//-------------------------------------------------
// Prototypes of the RX8_2 API.
//-------------------------------------------------
extern void  RX8_2_EnableInt(void);
extern void  RX8_2_DisableInt(void);
extern void  RX8_2_Start(BYTE bParity);
extern void  RX8_2_Stop(void);
extern BYTE  RX8_2_bReadRxData(void);
extern BYTE  RX8_2_bReadRxStatus(void);

// High level RX functions
extern CHAR         RX8_2_cGetChar(void);
extern CHAR         RX8_2_cReadChar(void);
extern INT          RX8_2_iReadChar(void);

#if ( RX8_2_RXBUF_ENABLE )
extern void   RX8_2_CmdReset(void);
extern BYTE   RX8_2_bCmdCheck(void);
extern BYTE   RX8_2_bErrCheck(void);
extern BYTE   RX8_2_bCmdLength(void);
extern char * RX8_2_szGetParam(void);
extern char * RX8_2_szGetRestOfParams(void);
#endif

// Old function call names, do not use.
// These names will be removed in a future release.
#pragma fastcall16 bRX8_2_ReadRxData
#pragma fastcall16 bRX8_2_ReadRxStatus
extern BYTE bRX8_2_ReadRxData(void);
extern BYTE bRX8_2_ReadRxStatus(void);

//-------------------------------------------------
// Constants for RX8_2 API's.
//-------------------------------------------------

//------------------------------------
// Receiver Interrupt masks
//------------------------------------
#define RX8_2_INT_REG_ADDR                     ( 0x0df )
#define RX8_2_bINT_MASK                        ( 0x80 )

//------------------------------------
// Receiver Parity masks
//------------------------------------
#define  RX8_2_PARITY_NONE         0x00
#define  RX8_2_PARITY_EVEN         0x02
#define  RX8_2_PARITY_ODD          0x06

//------------------------------------
//  Receiver Status Register masks
//------------------------------------
#define  RX8_2_RX_ACTIVE           0x10
#define  RX8_2_RX_COMPLETE         0x08
#define  RX8_2_RX_PARITY_ERROR     0x80
#define  RX8_2_RX_OVERRUN_ERROR    0x40
#define  RX8_2_RX_FRAMING_ERROR    0x20
#define  RX8_2_RX_NO_ERROR         0xE0

#define  RX8_2_RX_NO_DATA         0x01

#define  RX8_2_RX_BUF_ERROR               0xF0  // Mask for any Rx that may occur.
#define  RX8_2_RX_BUF_OVERRUN             0x10  // This indicates the software buffer has
                                                           // been over run.
#define  RX8_2_RX_BUF_CMDTERM             0x01  // Command terminator has been received.

// Old defines, will be removed in future release
#define  RX8_PARITY_NONE         0x00
#define  RX8_PARITY_EVEN         0x02
#define  RX8_PARITY_ODD          0x06
#define  RX8_RX_ACTIVE           0x10
#define  RX8_RX_COMPLETE         0x08
#define  RX8_RX_PARITY_ERROR     0x80
#define  RX8_RX_OVERRUN_ERROR    0x40
#define  RX8_RX_FRAMING_ERROR    0x20
#define  RX8_RX_NO_ERROR         0xE0

//-------------------------------------------------
// Register Addresses for RX8_2
//-------------------------------------------------
#pragma ioport  RX8_2_CONTROL_REG:  0x05f                  // Control register
BYTE            RX8_2_CONTROL_REG;
#pragma ioport  RX8_2_RX_SHIFT_REG: 0x05c                  // RX Shift Register register
BYTE            RX8_2_RX_SHIFT_REG;
#pragma ioport  RX8_2_RX_BUFFER_REG:    0x05e              // RX Buffer Register
BYTE            RX8_2_RX_BUFFER_REG;
#pragma ioport  RX8_2_FUNC_REG: 0x15c                      // Function register
BYTE            RX8_2_FUNC_REG;
#pragma ioport  RX8_2_INPUT_REG:    0x15d                  // Input register
BYTE            RX8_2_INPUT_REG;
#pragma ioport  RX8_2_OUTPUT_REG:   0x15e                  // Output register
BYTE            RX8_2_OUTPUT_REG;

// end of file RX8_2.h

