;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Timer16_1.inc
;;   Version: 2.5, Updated on 2006/06/19 at 11:17:22
;;  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
;;
;;  DESCRIPTION: Assembler declarations for the Timer16 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for Timer16_1 API's.
;--------------------------------------------------

Timer16_1_CONTROL_REG_START_BIT:           equ 0x01    ; Control register start bit
Timer16_1_INT_REG:                         equ 0x0df
Timer16_1_INT_MASK:                        equ 0x20


;--------------------------------------------------
; Constants for Timer16_1 user defined values
;--------------------------------------------------

Timer16_1_PERIOD:                          equ 0x9f
Timer16_1_COMPARE_VALUE:                   equ 0x0


;--------------------------------------------------
; Register Address Constants for Timer16_1
;--------------------------------------------------

Timer16_1_COUNTER_LSB_REG:             equ 0x50   ; DR0 Counter register
Timer16_1_COUNTER_MSB_REG:             equ 0x54
Timer16_1_PERIOD_LSB_REG:              equ 0x51   ; DR1 Period register
Timer16_1_PERIOD_MSB_REG:              equ 0x55
Timer16_1_COMPARE_LSB_REG:             equ 0x52   ; DR2 CompareValue register
Timer16_1_COMPARE_MSB_REG:             equ 0x56
Timer16_1_CONTROL_LSB_REG:             equ 0x53   ; Control register
Timer16_1_CONTROL_MSB_REG:             equ 0x57
Timer16_1_FUNC_LSB_REG:                equ 0x50   ; Function register
Timer16_1_FUNC_MSB_REG:                equ 0x54
Timer16_1_INPUT_LSB_REG:               equ 0x51   ; Input register
Timer16_1_INPUT_MSB_REG:               equ 0x55
Timer16_1_OUTPUT_LSB_REG:              equ 0x52   ; Output register
Timer16_1_OUTPUT_MSB_REG:              equ 0x56


;--------------------------------------------------
; Timer16_1 Macro 'Functions'
;--------------------------------------------------

   macro Timer16_1_Start_M
   or    reg[Timer16_1_CONTROL_LSB_REG],  Timer16_1_CONTROL_REG_START_BIT
   endm

   macro Timer16_1_Stop_M
   and   reg[Timer16_1_CONTROL_LSB_REG], ~Timer16_1_CONTROL_REG_START_BIT
   endm

   macro Timer16_1_EnableInt_M
   M8C_EnableIntMask Timer16_1_INT_REG, Timer16_1_INT_MASK
   endm

   macro Timer16_1_DisableInt_M
   M8C_DisableIntMask Timer16_1_INT_REG, Timer16_1_INT_MASK
   endm


; end of file Timer16_1.inc
